/*
 *  Copyright (C) 2005 Kouji TAKAO <kouji@netlab.jp>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GPASS_GNOME_ATTRIBUTE_EDITOR_H__
#define __GPASS_GNOME_ATTRIBUTE_EDITOR_H__

#include "view.h"
#include "gpass/entry.h"
#include "attribute-widgets.h"

G_BEGIN_DECLS

#define GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR \
    (gpass_gnome_attribute_editor_get_type())
#define GPASS_GNOME_ATTRIBUTE_EDITOR(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj), GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR, \
                                GPassGnomeAttributeEditor))
#define GPASS_GNOME_ATTRIBUTE_EDITOR_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass), GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR, \
                             GPassGnomeAttributeEditorClass))
#define GPASS_IS_GNOME_ATTRIBUTE_EDITOR(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj), GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR))
#define GPASS_IS_GNOME_ATTRIBUTE_EDITOR_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass), GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR))
#define GPASS_GNOME_ATTRIBUTE_EDITOR_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS((obj), GPASS_TYPE_GNOME_ATTRIBUTE_EDITOR, \
                               GPassGnomeAttributeEditorClass))

typedef struct {
    GPassView parent;

    GPassGnomeAttribute *type_attribute;
    GList *widgets;
    GHashTable *hash;
} GPassGnomeAttributeEditor;

typedef struct {
    GPassViewClass parent;
} GPassGnomeAttributeEditorClass;

GType gpass_gnome_attribute_editor_get_type(void);

void gpass_gnome_attribute_editor_set(GPassGnomeAttributeEditor *self,
                                      const gchar *type,
                                      GPassAttributeList *attributes,
                                      gboolean has_child);
void gpass_gnome_attribute_editor_get(GPassGnomeAttributeEditor *self,
                                      const gchar **type,
                                      GPassAttributeList **attributes);

G_END_DECLS

#endif /* #ifndef __GPASS_GNOME_ATTRIBUTE_EDITOR_H__ */
