/*
 *  Copyright (C) 2005 Kouji TAKAO <kouji@netlab.jp>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef __GPASS_VIEW_FACTORY_H__
#define __GPASS_VIEW_FACTORY_H__

#include <glib-object.h>

#include "view.h"

G_BEGIN_DECLS

#define GPASS_TYPE_VIEW_FACTORY (gpass_view_factory_get_type())
#define GPASS_VIEW_FACTORY(obj) \
    (G_TYPE_CHECK_INSTANCE_CAST((obj), GPASS_TYPE_VIEW_FACTORY, \
                                GPassViewFactory))
#define GPASS_VIEW_FACTORY_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_CAST((klass), GPASS_TYPE_VIEW_FACTORY, \
                             GPassViewFactoryClass))
#define GPASS_IS_VIEW_FACTORY(obj) \
    (G_TYPE_CHECK_INSTANCE_TYPE((obj), GPASS_TYPE_VIEW_FACTORY))
#define GPASS_IS_VIEW_FACTORY_CLASS(klass) \
    (G_TYPE_CHECK_CLASS_TYPE((klass), GPASS_TYPE_VIEW_FACTORY))
#define GPASS_VIEW_FACTORY_GET_CLASS(obj) \
    (G_TYPE_INSTANCE_GET_CLASS((obj), GPASS_TYPE_VIEW_FACTORY, \
                               GPassViewFactoryClass))

typedef struct {
    GObject parent;
    GHashTable *views;
    GHashTable *get_types;
} GPassViewFactory;

typedef struct {
    GObjectClass parent;
} GPassViewFactoryClass;

GType gpass_view_factory_get_type(void);
GError *gpass_view_factory_create_view(GPassViewFactory *self,
                                       const gchar *template,
                                       gpointer model, GPassView **view);
GError *gpass_view_factory_destroy_view(GPassViewFactory *self,
                                        const gchar *template);

G_END_DECLS

#endif /* #ifndef __GPASS_VIEW_FACTORY_H__ */
